----------------------------------------------------------------------------------
-- Company: 		comp. eng. KKU.
-- Engineer: 		TK
-- 
-- Create Date:    08:48:11 09/06/2011 
-- Design Name: 
-- Module Name:    ALUControl - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ALUControl is

	port(
		ALUOp			: in std_logic_vector(1 downto 0);
		funct			: in std_logic_vector(5 downto 0); -- IRout(5 downto 0)
		Binvert 		: out std_logic; 
		Operation 	: out std_logic_vector(1 downto 0) );

end ALUControl;

architecture Behavioral of ALUControl is

begin

	ALUControl: process(ALUOp, funct)
	begin
	
		case ALUop is
		when "00" =>
			-- lw/sw: add --
			Binvert <= '0';
			Operation <= "10";
		when "01" =>
			-- beq: sub --
			Binvert <= '1';
			Operation <= "10";
		when "10" =>
			-- R-type --
			case funct is
			when "100000" =>
			-- add --
			Binvert <= '0';
			Operation <= "10";
			
			when "100010" =>
			-- sub --
			Binvert <= '1';
			Operation <= "10";
			
			when "100100" =>
			-- and --
			Binvert <= '0';
			Operation <= "00";			
			
			when "100101" =>
			-- or --
			Binvert <= '0';
			Operation <= "01";
			
			when "101010" =>
			-- slt --
			Binvert <= '1';
			Operation <= "11";
						
			when others => Binvert <= '0'; Operation <= "00"; 
			end case;
		when others => 
			-- default case --
			Binvert <= '0';
			Operation <= "00";
		end case;
				
	end process;


end Behavioral;

