----------------------------------------------------------------------------------
-- Company: 	comp. engr. KKU.
-- Engineer: 	TK
-- 
-- Create Date:    13:33:08 08/18/2011 
-- Design Name: 
-- Module Name:    BitALU_tb - Behavioral 
-- Project Name: 	CH04
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
-- "Success is not final. Failure is not fatal. Only courage to continue that counts." - Winston Churchill
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity BitALU_tb is
end BitALU_tb;

architecture Behavioral of BitALU_tb is

    COMPONENT BitALU
    Port ( a : in  STD_LOGIC;
           b : in  STD_LOGIC;
           cin : in  STD_LOGIC;
           Qo : out  STD_LOGIC;
           cout : out  STD_LOGIC;
           operation : in STD_LOGIC_VECTOR (1 downto 0);
           Binvert : in  STD_LOGIC;
			  Lessin : in STD_LOGIC );
    END COMPONENT;

    SIGNAL sa 		: std_logic := '0';
    SIGNAL sb 		: std_logic := '0';
    SIGNAL scin 	: std_logic := '0';
    SIGNAL sQo 	: std_logic;
    SIGNAL scout	: std_logic;
    SIGNAL sop 	: std_logic_vector (1 downto 0) := "00";
    SIGNAL sBinv 	: std_logic := '0';
    SIGNAL sLess 	: std_logic := '0';

    constant PERIOD : time := 10 ns;

begin

        BALU : BitALU
        PORT MAP (
				a 		=> sa,
				b 		=> sb,
				cin 	=> scin,
				Qo 	=> sQo,
				cout 	=> scout,
				operation 	=> sop,
				Binvert 		=> sBinv,
				Lessin 		=> sLess
        );

        PROCESS 	-- running a, b, cin
        BEGIN
            RUN_LOOP : LOOP
                sa <= '0';
					 sb <= '0';
					 scin <= '0';
                WAIT FOR PERIOD;

                sa <= '0';
					 sb <= '0';
					 scin <= '1';
                WAIT FOR PERIOD;

                sa <= '0';
					 sb <= '1';
					 scin <= '0';
                WAIT FOR PERIOD;

                sa <= '0';
					 sb <= '1';
					 scin <= '1';
                WAIT FOR PERIOD;

                sa <= '1';
					 sb <= '0';
					 scin <= '0';
                WAIT FOR PERIOD;

                sa <= '1';
					 sb <= '0';
					 scin <= '1';
                WAIT FOR PERIOD;

                sa <= '1';
					 sb <= '1';
					 scin <= '0';
                WAIT FOR PERIOD;

                sa <= '1';
					 sb <= '1';
					 scin <= '1';
                WAIT FOR PERIOD;

            END LOOP RUN_LOOP;
      END PROCESS;

		PROCESS 	-- running Operation, Binv, Less
      BEGIN
					sop 		<= "00";
					sBinv		<= '0';
					sLess		<= '0';
					WAIT FOR 8*PERIOD;
					
					sop 		<= "00";
					sBinv		<= '1';
					sLess		<= '0';
					WAIT FOR 8*PERIOD;

					sop 		<= "01";
					sBinv		<= '0';
					sLess		<= '0';
					WAIT FOR 8*PERIOD;
					
					sop 		<= "01";
					sBinv		<= '1';
					sLess		<= '0';
					WAIT FOR 8*PERIOD;

					sop 		<= "10";
					sBinv		<= '0';
					sLess		<= '0';
					WAIT FOR 8*PERIOD;
					
					sop 		<= "10";
					sBinv		<= '1';
					sLess		<= '0';
					WAIT FOR 8*PERIOD;

					sop 		<= "11";
					sBinv		<= '0';
					sLess		<= '0';
					WAIT FOR 8*PERIOD;
					
					sop 		<= "11";
					sBinv		<= '0';
					sLess		<= '1';
					WAIT FOR 8*PERIOD;

					sop 		<= "11";
					sBinv		<= '1';
					sLess		<= '0';
					WAIT FOR 8*PERIOD;
					
					sop 		<= "11";
					sBinv		<= '1';
					sLess		<= '1';
					WAIT FOR 8*PERIOD;


		END PROCESS;
	 


end Behavioral;

