----------------------------------------------------------------------------------
-- Company: 	comp. engr. KKU.
-- Engineer: 	TK
-- 
-- Create Date:    08:50:17 08/19/2011 
-- Design Name: 
-- Module Name:    DFlipFlop - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
-- "Do not dwell in the past, do not dream of the future, concentrate the mind on the present moment." - Buddha 
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity DFlipFlop is
    Port ( clk : in  STD_LOGIC;
           D : in  STD_LOGIC;
           set : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           Q : out  STD_LOGIC;
           Qbar : out  STD_LOGIC);
end DFlipFlop;

architecture Behavioral of DFlipFlop is

begin
	process (clk)
	begin
		if clk'event and clk='1' then
			if reset='1' then
				Q 		<= '0';
				Qbar 	<= '1';
			elsif set='1' then
				Q 		<= '1';
				Qbar	<= '0';
			else
				Q 		<= D;
				Qbar 	<= not D;
			end if;
		end if;
	end process;

end Behavioral;

