----------------------------------------------------------------------------------
-- Company: 		comp. engr. KKU.
-- Engineer: 		TK
-- 
-- Create Date:    09:06:58 08/19/2011 
-- Design Name: 
-- Module Name:    DFlipFlop_tb - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
-- "Nobody can go back and start a new beginning, but anyone can start today and make a new ending."
-- Maria Robinson

----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity DFlipFlop_tb is
end DFlipFlop_tb;

architecture Behavioral of DFlipFlop_tb is

	COMPONENT DFlipFlop
   Port ( clk : in  STD_LOGIC;
           D : in  STD_LOGIC;
           set : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           Q : out  STD_LOGIC;
           Qbar : out  STD_LOGIC);
	END COMPONENT;

	SIGNAL sclk : 		STD_LOGIC := '0';
   SIGNAL sD : 		STD_LOGIC := '0';
   SIGNAL sset : 		STD_LOGIC := '0';
	SIGNAL sreset : 	STD_LOGIC := '0';
   SIGNAL sQ : 		STD_LOGIC;	
   SIGNAL sQbar : 	STD_LOGIC;
	
	constant PERIOD : time := 10 ns;

begin

	DFF:	DFlipFlop
	PORT MAP (
		clk 	=> sclk,
		D 		=> sD,
      set 	=> sset,
      reset => sreset,
      Q 		=> sQ,
      Qbar	=> sQbar
	);

	PROCESS	-- clk
   BEGIN
		RUN_LOOP : LOOP
            sclk <= '0';
				WAIT FOR PERIOD/2;
            sclk <= '1';
				WAIT FOR PERIOD/2;
		END LOOP RUN_LOOP;
   END PROCESS;

	PROCESS 	-- SIGNAL
	BEGIN
            sset <= '1';
				sreset <= '0';
				sD <= '0';
			
				WAIT FOR PERIOD*5/4;
            sset <= '0';
				WAIT FOR PERIOD;
            sD <= '0';
				WAIT FOR PERIOD;
            sD <= '1';
				WAIT FOR PERIOD;
				sreset <= '1';
				WAIT FOR PERIOD *3/4;
				sreset <= '0';
				WAIT FOR PERIOD;
   END PROCESS;


end Behavioral;

