----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    08/20/2011 
-- Design Name: 
-- Module Name:    MSBALU - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity MSBALU is
    Port ( a : in  STD_LOGIC;
           b : in  STD_LOGIC;
           cin : in  STD_LOGIC;
           Qo : out  STD_LOGIC;
			  set : out STD_LOGIC;
			  overflow : out STD_LOGIC;
           operation : in STD_LOGIC_VECTOR (1 downto 0);
           Binvert : in  STD_LOGIC;
			  Lessin : in STD_LOGIC);
end MSBALU;
	
architecture Behavioral of MSBALU is

	component mux4TO1
		port ( sel : in STD_LOGIC_VECTOR(1 downto 0); in0, in1, in2, in3 : in STD_LOGIC; Q : out STD_LOGIC);
	end component;
	
	component fulladder 
		port (a, b, ci: in STD_LOGIC; sum, co : out STD_LOGIC);
	end component;

	component OVFDetection
		port ( 	Binv, a, b, sum : in  STD_LOGIC;
					overflow : out  STD_LOGIC);
	end component;

	signal ANDout 		: STD_LOGIC;
	signal ORout 		: STD_LOGIC;
	signal ADDERout 	: STD_LOGIC;
	signal bi			: STD_LOGIC;
	signal cout			: STD_LOGIC;

begin
		bi <= ((not Binvert) and b ) or (Binvert and not b);
		
		ANDout <= a and bi;
		ORout <= a or bi;
		FA: fulladder port map (a, bi, cin, ADDERout, cout);
		
		MX: mux4TO1 port map (sel => operation, in0 => ANDout, in1 => ORout, 
										in2 => ADDERout, in3 => Lessin, Q => Qo);

		OVF: OVFDetection port map (Binv => Binvert, a => a, b => b, sum => ADDERout,
												overflow => overflow);

		set <= ADDERout;
		
end Behavioral;

