----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:16:06 08/20/2011 
-- Design Name: 
-- Module Name:    OVFDetection - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity OVFDetection is
    Port ( Binv : in  STD_LOGIC;
           a : in  STD_LOGIC;
           b : in  STD_LOGIC;
           sum : in  STD_LOGIC;
           overflow : out  STD_LOGIC);
end OVFDetection;

architecture Behavioral of OVFDetection is

	SIGNAL addpos 		: std_logic;
	SIGNAL addneg 		: std_logic;
	SIGNAL subpn 		: std_logic;
	SIGNAL subnp 		: std_logic;

begin

	addpos 	<= (not Binv) 	and (not a) 	and (not b) and sum;
	addneg	<= (not Binv) 	and a 			and b 		and (not sum);
	subpn 	<= Binv 			and (not a) 	and b 		and sum;
	subnp 	<= Binv 			and a 			and (not b) and (not sum);

	overflow <= addpos or addneg or subpn or subnp; 

end Behavioral;

