----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    08:54:36 08/22/2011 
-- Design Name: 
-- Module Name:    WordALU - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity WordALU is
    Port ( a : in  STD_LOGIC_VECTOR (31 downto 0);
           b : in  STD_LOGIC_VECTOR (31 downto 0);
           Binvert : in  STD_LOGIC;
           CarryIn : in  STD_LOGIC;
           Operation : in  STD_LOGIC_VECTOR (1 downto 0);
           Result : out  STD_LOGIC_VECTOR (31 downto 0);
           Overflow : out  STD_LOGIC;
			  Zero	: out STD_LOGIC);
end WordALU;

architecture Behavioral of WordALU is

    COMPONENT BitALU
    Port ( a, b, cin, Binvert, Lessin : in  STD_LOGIC;
           Qo, cout : out  STD_LOGIC;
           operation : in STD_LOGIC_VECTOR (1 downto 0)
			);
    END COMPONENT;

	component MSBALU 
		port (
				a, b, cin, Binvert, Lessin : in  STD_LOGIC; 
				Qo, set, overflow : out  STD_LOGIC;
				operation : in STD_LOGIC_VECTOR (1 downto 0)
		);
	end component;

	signal c: STD_LOGIC_VECTOR (31 downto 0);
	signal set : STD_LOGIC;
	signal qr: STD_LOGIC_VECTOR (31 downto 0);
	
begin

	c(0) <= CarryIn;

	bit0: BitALU port map(
			a => a(0),
			b => b(0),
			cin => c(0),
			Binvert => Binvert,
			Lessin => set,
			Qo => qr(0),
			cout => c(1),
			operation => Operation
	);

	bits1to30: for i in 1 to 30 generate
		ibit: BitALU port map(
			a => a(i),
			b => b(i),
			cin => c(i),
			Binvert => Binvert,
			Lessin => '0',
			Qo => qr(i),
			cout => c(i+1),
			operation => Operation
		);
	end generate;

	bit31: MSBALU port map (
			a => a(31), 
			b => b(31), 
			cin => c(31), 
			Binvert => Binvert, 
			Lessin => '0', 
			Qo => qr(31), 
			set => set, 
			overflow => Overflow,
			operation => Operation
	);

	Result <= qr;
	
	Zero <= 	not (
				qr(0) 	or qr(1) 	or qr(2) 	or qr(3) 	or 
				qr(4) 	or qr(5) 	or qr(6) 	or qr(7) 	or 
				qr(8) 	or qr(9) 	or qr(10) 	or qr(11) 	or 
				qr(12) 	or qr(13) 	or qr(14) 	or qr(15) 	or 
				qr(16) 	or qr(17) 	or qr(18) 	or qr(19) 	or 
				qr(20) 	or qr(21) 	or qr(22) 	or qr(23) 	or 
				qr(24) 	or qr(25) 	or qr(26) 	or qr(27) 	or 
				qr(28) 	or qr(29) 	or qr(30) 	or qr(31) );

end Behavioral;

