----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    21:05:13 09/04/2011 
-- Design Name: 
-- Module Name:    ch5mem_tb - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity ch5mem_tb is
end ch5mem_tb;

architecture Behavioral of ch5mem_tb is

component ch5mem is
	port
	(
		clock				: in  std_logic;
		datain			: in  std_logic_vector(31 downto 0);
		memaddress		: in  std_logic_vector(31 downto 0);
		memwrite			: in  std_logic;
		memread			: in  std_logic;
		dataout			: out std_logic_vector(31 downto 0);
		enable			: in std_logic;
		startup			: in  std_logic	-- to load pre-written data
	);
end component;

signal	clk			: std_logic;
signal	data			: std_logic_vector(31 DOWNTO 0);
signal	addr			: std_logic_vector(31 DOWNTO 0);
signal	memwrite		: std_logic;
signal	memread		: std_logic;
signal	q				: std_logic_vector(31 DOWNTO 0);
signal	en				: std_logic;
signal	startup		: std_logic;


constant PERIOD : time := 50 ns;

begin

	mem: ch5mem
	port map (
		clock 		=> clk, 
		datain 		=> data,
		memaddress 	=> addr, 
		memwrite 	=> memwrite,
		memread		=> memread,
		dataout 		=> q,
		enable		=> en,
		startup		=> startup);

	process
	begin
		clk <= '0';
		wait for PERIOD/2;
		clk <= '1';
		wait for PERIOD/2;
	end process;
	
PROCESS
   BEGIN
		en	<= '1';

--		startup <= '1';
--		wait for PERIOD/10;
		startup <= '0';
		wait for PERIOD/20;
		startup <= '1';
		wait for PERIOD/10;
		startup <= '0';

		
		-- test read pre-written data --
		memread <= '1';
		memwrite <= '0';
		
		addr <= x"10000000";
		wait for PERIOD;
		
		addr <= x"10000004";
		wait for PERIOD;

		-- test write memory --
		memread <= '0';
		wait for PERIOD/4;
		
		memwrite <= '1';
		addr <= x"10000000";
		data <= x"00000028";
		wait for PERIOD * 3/4;
		
		-- test read memory after re-written --
		memwrite <= '0';
		wait for PERIOD/4;
		
		memread <= '1';
		addr <= x"10000000";
		wait for PERIOD * 3/4;

		-- test read pre-written program --
		memread <= '1';
		addr <= x"00400000";
		wait for PERIOD/2;

		addr <= x"00400004";
		wait for PERIOD;
		
		addr <= x"00400008";
		wait for PERIOD;
		
		addr <= x"0040000C";
		wait for PERIOD;

		addr <= x"00400010";
		wait for PERIOD;

		addr <= x"00400014";
		wait for PERIOD;
		
		addr <= x"00400018";
		wait for PERIOD;
		
		addr <= x"0040001C";
		wait for PERIOD;

		addr <= x"00400020";
		wait for PERIOD;

		-- test overwrite program segment --
		memread <= '0';
		
		addr <= x"00400000";
		data <= x"00000000";
		wait for PERIOD/4;

		memwrite <= '1';
		wait for PERIOD * 3/4;
		
		memwrite <= '0';
		wait for PERIOD/4;
		
		memread <= '1';
		wait for PERIOD * 3/4;
		
		addr <= x"00400004";
		wait for PERIOD/2;
		
		en <= '0';
		wait for PERIOD/2;
		
		-- set simulation time to 950ns		


   END PROCESS;

end Behavioral;

