--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   16:58:50 09/05/2011
-- Design Name:   
-- Module Name:   C:/xilinx_tutorial/Ch05/datapath_tb.vhd
-- Project Name:  Ch05
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: datapath
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY datapath_tb IS
END datapath_tb;
 
ARCHITECTURE behavior OF datapath_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT datapath
    PORT(
         clock : IN  std_logic;
         memdatain : IN  std_logic_vector(31 downto 0);
         memdataout : OUT  std_logic_vector(31 downto 0);
         memaddress : OUT  std_logic_vector(31 downto 0);
         memwrite : OUT  std_logic;
         memread : OUT  std_logic;
         startup : IN  std_logic;
			stagecheck : OUT std_logic_vector(2 downto 0)
        );
    END COMPONENT;

	component ch5mem is
	port
	(
		clock				: in  std_logic;
		datain			: in  std_logic_vector(31 downto 0);
		memaddress		: in  std_logic_vector(31 downto 0);
		memwrite			: in  std_logic;
		memread			: in  std_logic;
		dataout			: out std_logic_vector(31 downto 0);
		enable			: in std_logic;
		startup			: in  std_logic	-- to load pre-written data
	);
	end component;

    

   --Inputs
   signal clock : std_logic := '0';
   signal memdatain : std_logic_vector(31 downto 0) := (others => '0');
   signal startup : std_logic := '0';

 	--Outputs
   signal memdataout : std_logic_vector(31 downto 0);
   signal memaddress : std_logic_vector(31 downto 0);
   signal memwrite : std_logic;
   signal memread : std_logic;
	
	signal stagecheck : std_logic_vector(2 downto 0);

   -- Clock period definitions
   constant clock_period : time := 10 ns;
 
BEGIN
 
 	mem: ch5mem
	port map (
		clock 		=> clock, 
		datain 		=> memdataout,
		memaddress 	=> memaddress, 
		memwrite 	=> memwrite,
		memread		=> memread,
		dataout 		=> memdatain,
		enable		=> '1',
		startup		=> startup);

 
	-- Instantiate the Unit Under Test (UUT)
   uut: datapath PORT MAP (
          clock => clock,
          memdatain => memdatain,
          memdataout => memdataout,
          memaddress => memaddress,
          memwrite => memwrite,
          memread => memread,
          startup => startup,
			 stagecheck => stagecheck
        );

   -- Clock process definitions
   clock_process :process
   begin
		clock <= '0';
		wait for clock_period/2;
		clock <= '1';
		wait for clock_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
	
		startup <= '0';
		wait for clock_period/10;

		startup <= '1';
      -- hold reset state for 100 ns.
      wait for clock_period/2;	

		startup <= '0';
		wait;
   end process;

END;
