--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   08:08:24 09/06/2011
-- Design Name:   
-- Module Name:   C:/xilinx_tutorial/Ch05/maincontrol_tb.vhd
-- Project Name:  Ch05
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: maincontrol
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY maincontrol_tb IS
END maincontrol_tb;
 
ARCHITECTURE behavior OF maincontrol_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT maincontrol
    PORT(
         PCWriteCond : OUT  std_logic;
         PCWrite : OUT  std_logic;
         PCSource : OUT  std_logic_vector(1 downto 0);
         MemRead : OUT  std_logic;
         MemWrite : OUT  std_logic;
         IorD : OUT  std_logic;
         IRWrite : OUT  std_logic;
         ALUop : OUT  std_logic_vector(1 downto 0);
         ALUSrcB : OUT  std_logic_vector(1 downto 0);
         ALUSrcA : OUT  std_logic;
         RegWrite : OUT  std_logic;
         RegDst : OUT  std_logic;
         MemtoReg : OUT  std_logic;
         stagein : IN  std_logic_vector(2 downto 0);
         opcode : IN  std_logic_vector(5 downto 0);
         stageout : OUT  std_logic_vector(2 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal stagein : std_logic_vector(2 downto 0) := (others => '0');
   signal opcode : std_logic_vector(5 downto 0) := (others => '0');

 	--Outputs
   signal PCWriteCond : std_logic;
   signal PCWrite : std_logic;
   signal PCSource : std_logic_vector(1 downto 0);
   signal MemRead : std_logic;
   signal MemWrite : std_logic;
   signal IorD : std_logic;
   signal IRWrite : std_logic;
   signal ALUop : std_logic_vector(1 downto 0);
   signal ALUSrcB : std_logic_vector(1 downto 0);
   signal ALUSrcA : std_logic;
   signal RegWrite : std_logic;
   signal RegDst : std_logic;
   signal MemtoReg : std_logic;
   signal stageout : std_logic_vector(2 downto 0);
   -- No clocks detected in port list. Replace <clock> below with 
   -- appropriate port name 
 
   constant period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: maincontrol PORT MAP (
          PCWriteCond => PCWriteCond,
          PCWrite => PCWrite,
          PCSource => PCSource,
          MemRead => MemRead,
          MemWrite => MemWrite,
          IorD => IorD,
          IRWrite => IRWrite,
          ALUop => ALUop,
          ALUSrcB => ALUSrcB,
          ALUSrcA => ALUSrcA,
          RegWrite => RegWrite,
          RegDst => RegDst,
          MemtoReg => MemtoReg,
          stagein => stagein,
          opcode => opcode,
          stageout => stageout
        );

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 20 ns;	

		stagein <= "000";
      wait for period;

		-- r-type --
      opcode  <= "000000";

		stagein <= "001";
      wait for period;

		stagein <= "010";
      wait for period;
      
		stagein <= "011";
      wait for period;
		
		stagein <= "100";
      wait for period;

		-- lw --
      opcode  <= "100011";

		stagein <= "001";
      wait for period;
      
		stagein <= "010";
      wait for period;
		
		stagein <= "011";
      wait for period;

		stagein <= "100";
      wait for period;

		stagein <= "101";
      wait for period;

		-- sw --
      opcode  <= "101011";

		stagein <= "001";
      wait for period;
      
		stagein <= "010";
      wait for period;
		
		stagein <= "011";
      wait for period;
		
		stagein <= "100";
      wait for period;

		-- beq --
      opcode  <= "000100";

		stagein <= "001";
      wait for period;
      
		stagein <= "010";
      wait for period;

		stagein <= "011";
      wait for period;

		-- j --
      opcode  <= "000010";

		stagein <= "001";
      wait for period;
      
		stagein <= "010";
      wait for period;

		stagein <= "011";
      wait for period;

		-- simulation time = 300 ns --
      wait;
   end process;

END;
