----------------------------------------------------------------------------------
-- Company: 		comp. engr. KKU.
-- Engineer: 		TK
-- 
-- Create Date:    09/03/2011 
-- Design Name: 
-- Module Name:    mem32_tb - Behavioral 
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity mem32_tb is
end mem32_tb;

architecture Behavioral of mem32_tb is

component memunit is
	generic
	(
		ADDRESS_WIDTH	: integer := 16;
		DATA_WIDTH		: integer := 8
	);
	port
	(
		clock				: IN  std_logic;
		datain			: IN  std_logic_vector(DATA_WIDTH - 1 DOWNTO 0);
		memaddress		: IN  std_logic_vector(ADDRESS_WIDTH - 1 DOWNTO 0);
		memwrite			: IN  std_logic;
		memread			: IN  std_logic;
		dataout			: OUT std_logic_vector(DATA_WIDTH - 1 DOWNTO 0)
	);
end component;

signal	clk			: std_logic;
signal	data			: std_logic_vector(7 DOWNTO 0);
signal	addr			: std_logic_vector(15 DOWNTO 0);
signal	memwrite		: std_logic;
signal	memread		: std_logic;
signal	q				: std_logic_vector(7 DOWNTO 0);

constant PERIOD : time := 50 ns;

begin

	mem: memunit
	port map (
		clock 		=> clk, 
		datain 		=> data,
		memaddress 	=> addr, 
		memwrite 	=> memwrite,
		memread		=> memread,
		dataout 		=> q);

	PROCESS
	BEGIN
		clk <= '0';
		wait for PERIOD/2;
		clk <= '1';
		wait for PERIOD/2;
	END PROCESS;
	
	PROCESS
   BEGIN
		data <= X"0A";
		addr <= "0101010101010101";
		memwrite <= '1';
		memread <= '0';
		wait for PERIOD/4;
		
-- set simulation time to 650ns		

   END PROCESS;


end Behavioral;

