----------------------------------------------------------------------------------
-- Company: 			comp. engr. KKU.
-- Engineer: 			TK
-- 
-- Create Date:    	16:27:46 09/01/2011 
-- Design Name: 
-- Module Name:    	mux2_tb - Behavioral 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
-- "Memory can change the shape of a room; it can change the color of a car. 
-- And memories can be distorted. They're just an interpretation, they're not a record, 
-- and they're irrelevant if you have the facts." - Leonard Shelby in Memento (2000)
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity mux2_tb is
end mux2_tb;

architecture Behavioral of mux2_tb is

component mux2 is
port(
	sel: 		in std_logic;
	ch1:		in std_logic_vector(31 downto 0);
	ch2:		in std_logic_vector(31 downto 0);
	muxout:	out std_logic_vector (31 downto 0)
);
end component;

signal	sel: 		std_logic;
signal	ch1:		std_logic_vector(31 downto 0);
signal	ch2:		std_logic_vector(31 downto 0);
signal	muxout:	std_logic_vector (31 downto 0);

constant PERIOD 		: time := 100 ns;

begin

	mux: mux2
	port map (
		sel		=> sel,
		ch1		=> ch1,
		ch2		=> ch2,
		muxout	=> muxout);

	process
	begin
		ch1 <= X"0AAA00AA";
		ch2 <= X"0B00000B";
		
		sel <= '0';
		wait for PERIOD;
		ch1 <= X"1A1A11AA";
		wait for PERIOD/2;
		ch1 <= X"A00A00AA";
		wait for PERIOD/2;
		
		sel <= '1';
		wait for PERIOD;
		ch2 <= X"0C00000C";
		wait for PERIOD/4;
		ch2 <= X"0D00000D";
		wait for PERIOD/4;

		-- simulation time = 400 ns
	end process;


end Behavioral;

