----------------------------------------------------------------------------------
-- Company: 			comp. engr. KKU.
-- Engineer: 			TK
-- 
-- Create Date:    	12:34:46 09/02/2011 
-- Design Name: 
-- Module Name:    	mux4_tb - Behavioral 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
-- "You cannot dream yourself into a character; you must hammer and forge yourself one."
-- - By the English historian, James Anthony Froude (1818-1894) from his book, The Nemesis of Faith.

----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity mux4_tb is
end mux4_tb;

architecture Behavioral of mux4_tb is

component mux4 is
port(
	sel: 		in std_logic_vector(1 downto 0);
	ch1:		in std_logic_vector(31 downto 0);
	ch2:		in std_logic_vector(31 downto 0);
	ch3:		in std_logic_vector(31 downto 0);
	ch4:		in std_logic_vector(31 downto 0);	
	muxout:	out std_logic_vector (31 downto 0)
);
end component;

signal	sel: 		std_logic_vector(1 downto 0);
signal	ch1:		std_logic_vector(31 downto 0);
signal	ch2:		std_logic_vector(31 downto 0);
signal	ch3:		std_logic_vector(31 downto 0);
signal	ch4:		std_logic_vector(31 downto 0);
signal	muxout:	std_logic_vector (31 downto 0);

constant PERIOD 		: time := 100 ns;

begin

	mux: mux4
	port map (
		sel		=> sel,
		ch1		=> ch1,
		ch2		=> ch2,
		ch3		=> ch3,
		ch4		=> ch4,
		muxout	=> muxout);

	process
	begin
		ch1 <= X"10A000AA";
		ch2 <= X"20B0000B";
		ch3 <= X"30C0000C";
		ch4 <= X"40D0000D";
		
		sel <= "00";
		wait for PERIOD;

		ch1 <= X"111000AA";
		wait for PERIOD/2;
		
		ch1 <= X"122000AA";
		wait for PERIOD/2;
		
		sel <= "01";
		wait for PERIOD;
		
		sel <= "10";
		wait for PERIOD;
		
		sel <= "11";
		wait for PERIOD;

		-- simulation time = 500 ns
	end process;


end Behavioral;
