----------------------------------------------------------------------------------
-- Company: 		comp. engr. KKU.
-- Engineer: 		TK
-- 
-- Create Date:    11:53:57 08/29/2011 
-- Design Name: 
-- Module Name:    nbitregister - Behavioral 
-- Description: 
-- 	adapted from http://esd.cs.ucr.edu/labs/tutorial/register.vhd, retrieved on Aug, 29th, 2011.
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: "Attitude is a little thing that makes a big difference." - Winston Churchill 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity nbitregister is
generic(n: integer := 32);
port(
	win: 			in std_logic_vector (n-1 downto 0);
	clock:		in std_logic;
	regload:		in std_logic;
	regclear: 	in std_logic;
	wout:			out std_logic_vector (n-1 downto 0)
);
end nbitregister;

architecture Behavioral of nbitregister is

	signal wtmp : std_logic_vector (n-1 downto 0);

begin
	process(win, clock, regload, regclear)
	begin
		if regclear = '1' then
			wtmp <= (wtmp'range => '0');
		elsif (clock = '1' and clock'event) then
			if regload = '1' then
				wtmp <= win;
			end if;
		end if;
		
	end process;

	wout <= wtmp;

end Behavioral;