----------------------------------------------------------------------------------
-- Company: 		comp. engr. KKU.
-- Engineer: 		TK
-- 
-- Create Date:    12:15:13 08/29/2011 
-- Design Name: 
-- Module Name:    nbitregister_tb - Behavioral 
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity nbitregister_tb is
end nbitregister_tb;

architecture Behavioral of nbitregister_tb is

constant Nbits : integer := 32;

component nbitregister is
	 generic (n : integer := Nbits);
    Port ( 
		win: 			in std_logic_vector (Nbits-1 downto 0);
		clock:		in std_logic;
		regload:		in std_logic;
		regclear: 	in std_logic;
		wout:			out std_logic_vector (Nbits-1 downto 0));
end component;

signal win		: std_logic_vector (Nbits-1 downto 0);
signal clk	: std_logic;
signal regload	: std_logic;
signal regclear: std_logic;
signal wout		: std_logic_vector (Nbits-1 downto 0);

constant PERIOD : time := 50 ns;

begin

	reg: nbitregister
	port map (
		win => win, 
		clock => clk,
		regload => regload, 
		regclear => regclear,
		wout => wout);

	PROCESS
	BEGIN
		clk <= '0';
		wait for PERIOD/2;
		clk <= '1';
		wait for PERIOD/2;
	END PROCESS;
	
	PROCESS
   BEGIN
		win 		<= "11111111000000100000000110100010";
		regload 	<= '0';
		regclear	<= '0';
		wait for PERIOD/4;
		
		regload 	<= '1';
		wait for PERIOD;
		
		regload 	<= '0';
		regclear	<= '1';
		wait for PERIOD;
		
		-- simulation time = 150 ns
		
   END PROCESS;


end Behavioral;

