----------------------------------------------------------------------------------
-- Company: 		comp. engr. KKU.
-- Engineer: 		TK
-- 
-- Create Date:    15:32:13 08/29/2011 
-- Design Name: 
-- Module Name:    ram_tb - Behavioral 
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity ram_tb is
end ram_tb;

architecture Behavioral of ram_tb is

component ram is
	generic
	(
		ADDRESS_WIDTH	: integer := 16;		-- simulation overflow when using address_width 32
		DATA_WIDTH		: integer := 8
	);
	port
	(
		clock				: IN  std_logic;
		datain			: IN  std_logic_vector(DATA_WIDTH - 1 DOWNTO 0);
		memaddress		: IN  std_logic_vector(ADDRESS_WIDTH - 1 DOWNTO 0);
		memwrite			: IN  std_logic;
		memread			: IN  std_logic;
		dataout			: OUT std_logic_vector(DATA_WIDTH - 1 DOWNTO 0)
	);
end component;

signal	clk			: std_logic;
signal	data			: std_logic_vector(7 DOWNTO 0);
signal	addr			: std_logic_vector(15 DOWNTO 0);
signal	memwrite		: std_logic;
signal	memread		: std_logic;
signal	q				: std_logic_vector(7 DOWNTO 0);

constant PERIOD : time := 50 ns;

begin

	mem: ram
	port map (
		clock 		=> clk, 
		datain 		=> data,
		memaddress 	=> addr, 
		memwrite 	=> memwrite,
		memread		=> memread,
		dataout 		=> q);

	PROCESS
	BEGIN
		clk <= '0';
		wait for PERIOD/2;
		clk <= '1';
		wait for PERIOD/2;
	END PROCESS;
	
	PROCESS
   BEGIN
		data <= X"0A";
		addr <= X"0000";
		memwrite <= '1';
		memread <= '0';
		wait for PERIOD/4;
		
		data <= X"1B";
		addr <= X"0001";
		wait for PERIOD;

		data <= X"2C";
		addr <= X"0002";
		wait for PERIOD;

		data <= X"3D";
		addr <= X"0003";
		wait for PERIOD;

		memwrite <= '0';
		memread <= '1';
		addr <= X"0000";
		wait for PERIOD;
		
		addr <= X"0001";
		wait for PERIOD;

		addr <= X"0002";
		wait for PERIOD;

		addr <= X"0003";
		wait for PERIOD;

		addr <= X"0004";
		wait for PERIOD;
		
		addr <= X"0002";
		wait for PERIOD;

		memread <= '0';
		wait for PERIOD;
		
   END PROCESS;


end Behavioral;

